]> ruderich.org/simon Gitweb - config/dotfiles.git/blobdiff - setup.sh
setup.sh: Use sed_i().
[config/dotfiles.git] / setup.sh
index 3a5e7f2f6b637d4a858f0e1333d80f30880c72e6..d96f5df14cdc1e323a88194531e82997ec20509a 100755 (executable)
--- a/setup.sh
+++ b/setup.sh
@@ -64,17 +64,21 @@ perl < lesskey \
     | lesskey -
 chmod 0600 ~/.less
 
+# Custom colors for GNU ls.
+if installed dircolors; then
+    echo '# WARNING! DO NOT EDIT THIS FILE!' > shell/dircolors
+    dircolors -b shell/dircolors.in >> shell/dircolors
+fi
+
 # Find the required options to get colored ls output. GNU ls is preferred. See
 # shell/aliases.in for details. Doing this here instead of in shell/aliases
 # speeds up shell starts.
 #
 # Check if colors are available.
-ls --color > /dev/null 2>&1
-if test $? -eq 0; then
+if ls --color > /dev/null 2>&1; then
     ls_color=gnu
 else
-    ls -G > /dev/null 2>&1
-    if test $? -eq 0; then
+    if ls -G > /dev/null 2>&1; then
         ls_color=cli
     else
         ls_color=
@@ -95,22 +99,35 @@ else
     ls_env=
     ls_color=
 fi
+
+# Also check if `column -t` is available.
+if echo test | column -t >/dev/null 2>&1; then
+    column=' | column -t'
+else
+    column=
+fi
+
 generate perl shell/aliases \
     -e 'while (<STDIN>) {
             s/\bLS_ENV\b/$ARGV[0]/;
             s/\bLS_PATH\b/$ARGV[1]/;
             s/\bLS_COLOR\b/$ARGV[2]/;
+            s/\bCOLUMN\b/$ARGV[3]/;
             print;
         }' \
-    "$ls_env" "$ls_path" "$ls_color"
+    "$ls_env" "$ls_path" "$ls_color" "$column"
+
+# If `tig` is not available use my simple replacement.
+if ! installed tig; then
+    echo "alias tig='git tig'" >>shell/aliases
+fi
 
 # Check if grep supports --color=auto.
 if echo test | grep --color=auto test >/dev/null 2>&1; then
     :
 else
     echo 'shell/aliases: removing grep --color=auto'
-    sed '/^alias grep=/ s/^/#/' shell/aliases > shell/aliases.tmp
-    mv shell/aliases.tmp shell/aliases
+    sed_i '/^alias grep=/ s/^/#/' shell/aliases
 fi
 
 generate cat screenrc .in
@@ -145,9 +162,8 @@ if terminal_available screen-256color; then
 fi
 if test -z "$use_256colors"; then
     echo screenrc: removing 256 colors
-    sed 's/Enable 256 color/Disable 256 color/;
-         s/screen-256color/screen/' screenrc > screenrc.tmp
-    mv screenrc.tmp screenrc
+    sed_i 's/Enable 256 color/Disable 256 color/;
+           s/screen-256color/screen/' screenrc
 fi
 # Some options are only necessary when running as root. They are marked as
 # "(ROOT)".
@@ -168,8 +184,7 @@ fi
 # it's installed.
 if installed rxvt; then
     echo screenrc: removing attrcolor \"fix\"
-    sed 's/attrcolor b ".I"/#attrcolor b ".I"/' screenrc > screenrc.tmp
-    mv screenrc.tmp screenrc
+    sed_i 's/attrcolor b ".I"/#attrcolor b ".I"/' screenrc
 fi
 # Display current battery charge on computers with a battery. Necessary lines
 # are marked as "(BATTERY)".
@@ -198,15 +213,13 @@ if installed tmux; then
     # 256 colors not available.
     if test -z "$use_256colors"; then
         echo tmux.conf: removing 256 colors
-        sed 's/Enable 256 color/Disable 256 color/;
-             s/screen-256color/screen/' tmux.conf > tmux.conf.tmp
-        mv tmux.conf.tmp tmux.conf
+        sed_i 's/Enable 256 color/Disable 256 color/;
+               s/screen-256color/screen/' tmux.conf
     fi
     # Tmux doesn't display a warning if the shell wasn't found!
     if test ! -x '/bin/zsh'; then
         echo tmux.conf: removing /bin/zsh as shell
-        sed 's/zsh/sh/' tmux.conf > tmux.conf.tmp
-        mv tmux.conf.tmp tmux.conf
+        sed_i 's/zsh/sh/' tmux.conf
     fi
 fi
 
@@ -249,4 +262,6 @@ if installed htop; then
     mkdir -p ~/.config/htop
     link htoprc ~/.config/htop/htoprc
 fi
-
+if test -d ~/.ssh && test -O ~/.ssh; then
+    link ssh_config ~/.ssh/config
+fi